# coding: utf-8

"""
    Dashboards API

    Manage ThousandEyes Dashboards.

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from thousandeyes_sdk.dashboards.models.asw_repeat import AswRepeat
from thousandeyes_sdk.dashboards.models.asw_repeat_unit import AswRepeatUnit
from typing import Optional, Set
from typing_extensions import Self

class ApiDashboardAsw(BaseModel):
    """
    Alert suppression window shown in a widget.
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Identifier of the alert suppression window.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the alert suppression window.")
    test_ids: Optional[List[StrictStr]] = Field(default=None, alias="testIds")
    start_times: Optional[List[datetime]] = Field(default=None, alias="startTimes")
    duration_in_seconds: Optional[StrictInt] = Field(default=None, alias="durationInSeconds")
    repeat: Optional[AswRepeat] = None
    repeat_every: Optional[StrictInt] = Field(default=None, alias="repeatEvery")
    repeat_unit: Optional[AswRepeatUnit] = Field(default=None, alias="repeatUnit")
    __properties: ClassVar[List[str]] = ["id", "name", "testIds", "startTimes", "durationInSeconds", "repeat", "repeatEvery", "repeatUnit"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="allow",
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return self.model_dump_json(by_alias=True, exclude_unset=True, exclude_none=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApiDashboardAsw from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApiDashboardAsw from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "testIds": obj.get("testIds"),
            "startTimes": obj.get("startTimes"),
            "durationInSeconds": obj.get("durationInSeconds"),
            "repeat": obj.get("repeat"),
            "repeatEvery": obj.get("repeatEvery"),
            "repeatUnit": obj.get("repeatUnit")
        })
        return _obj


